﻿/*========================================================================================
(c) Dmitriy N. Sakharov
LastWordInFrame v1.0

Скрипт для запрета переноса последнего слова в текстовом фрейме.
Рекомендуется выполнять перед вычиткой (после чистовой врестки).
Перед началом работы необходимо выделить текстовый фрейм, с которого нужно начать обработку. 
Проверяется последнее слово в каждом текстовом фрейме, и если оно разбивается переносом, 
то ему назначается атрибут "Nobreak". При этом контролируется неизменность количества строк
в абзаце, в котором находится слово. При необходимости количество строк корректируется за счет
изменения кернинга в заданных пределах. Если корректировка не привела к должному результату, 
скрипт прекращает работу, выделяется нужный абзац  и выводится сообщение о неудаче.

Отзывы и замечания по работе скрипта направляйте на sakhar@mail.ru

ЕСЛИ СКРИПТ ПОМОГАЕТ ВАМ В РАБОТЕ, ОБЛЕГЧАЯ ВАШ ТРУД,
И ВЫ ХОТИТЕ ОТБЛАГОДАРИТЬ АВТОРА - ОКАЖИТЕ СПОНСОРСКУЮ ПОМОЩЬ В ЛЮБОМ РАЗМЕРЕ!!!
Узнать, как это сделать, можно по e-mail: sakhar@mail.ru.
=========================================================================================*/


with (app) {	
	// Проверка открытых документов
	if(app.documents.length == 0){
		alert("Нет открытых документов!");
		exit();
	}
	// Проверка выделения
	if((selection.length != 1)||(selection.length == 1 && selection[0].constructor.name != "TextFrame")){
		alert("Необходимо выделить текстовый фрейм");
		exit();
	}			
	var myDocument = activeDocument;
	var myFrame = selection[0];
	var minKern = -25;								// Минимально допустимый кернинг
	var maxKern = 25;								// Максимально допустимый кернинг
	do{	
		var myPara = myFrame.paragraphs.lastItem();
		var lnCount = myPara.lines.length;	
		try {
		while (myFrame.words.lastItem().index == myFrame.nextTextFrame.words.firstItem().index) {
			myDocument.layoutWindows[0].activePage = myFrame.parent;
			myFrame.words.lastItem().noBreak = true;
			while (myPara.lines.length != lnCount) {
				if (myPara.tracking >= minKern && myPara.lines.length > lnCount) {
					myPara.tracking = myPara.tracking - 5;
				}
				else if (myPara.tracking <= maxKern && myPara.lines.length < lnCount) {
					myPara.tracking = myPara.tracking + 5;
				}
				else {
					myDocument.layoutWindows[0].activePage = myFrame.parent;
					myPara.select();					
					alert("Не получается!");
					exit();
				}			
			}
		}
		}
		catch(err){
			alert("Корректировка успешно завершена!")
			exit();
		}
	} while (myFrame = myFrame.nextTextFrame)
}